#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <ctype.h>

void StrOut(char *, char *, int);
void PridetiZodi(char *, char *, int);
bool YraDidele(char []);

int main() {
	
	FILE *input;
	FILE *output;
	char *str_in;
	char *str_out;
	char f[20];
	unsigned int ilgis = 1000;

	int kiek = 0;

	do {
		if(kiek == 3) {
			printf("Error: neimanoma atidaryti failo.\n");
			return EXIT_FAILURE;
		}
		printf("Iveskite duomenu failo varda\n");
		scanf("%s", f);
		input = fopen(f, "r");
		kiek++;
	} while(input == NULL);

	printf("Iveskite rezultato failo varda\n");
	scanf("%s", f);
	output = fopen(f, "w");

	while (!feof(input)) {
		str_in = malloc(ilgis);
		fgets(str_in, ilgis, input);
		str_out = malloc(ilgis);
		str_out[0] = '\0';
		StrOut(str_in, str_out, ilgis);
		free(str_in);
		printf("%s", str_out);
		fputs(str_out, output);
		free(str_out);
	}

	fclose(output);
	fclose(input);
	
	return EXIT_SUCCESS;
}



void StrOut(char *strIn, char *strOut, int ilgis) {

	char *zodis;

	zodis = strtok (strIn, " \n");
	while (zodis != NULL) {
		
		if(YraDidele(zodis)) 
			PridetiZodi(zodis, strOut, ilgis);

		zodis = strtok (NULL, " \n");
	}

	strcat(strOut, "\n");
}



bool YraDidele(char zod[]) {

	//int i;
	char *s = zod;

	while (*s != '\0') {
		//if ((*s >= 'A') && (*s <= 'Z')) return true;
		if (isupper(*s)) return true;
		s++;
	}

	//for(i = 0; i < strlen(zod); i++)
	//	if((zod[i] > '@') && (zod[i] < '[')) return true;

	return false;
}



void PridetiZodi(char *zod, char *s, int ilgis) {

	if (strlen(s) != 0) {
		if (strlen(s) < ilgis)
			strcat(s, " ");
		if (strlen(s) + strlen(zod) < ilgis - 2)
			strcat(s, zod);
		else {
			printf("Eilutes ilgis virsyja %d. \"Nukasta\" eilute yra:", ilgis);
			strncat(s, zod, ilgis - strlen(s) - 2);
			//zod[ilgis - strlen(s) - 2] = '\0';
			//strcat(s, zod);
		}
	}
	else {
		if (strlen(zod) < ilgis)
			memcpy(s, zod, strlen(zod) + 1);
		else {
			printf("Eilutes ilgis virsyja %d. \"Nukasta\" eilute yra:", ilgis);
			memcpy(s, zod, ilgis - 2);
			strcat(s, '\0');
		}

	}

}